
import rivet
top = rivet.init()

class gctest1:
	def callback(self):
		pass # function just used to provide a callback reference
	def __del__(self):
		global teststatusok
		teststatusok = 1


# test bind cleanup on object demise
teststatusok = None
obj = gctest1()
b = rivet.button(top)
b.bind('<1>', obj.callback, 1)
del obj
rivet.destroy(b)
if teststatusok == None:
	print 'test 1 FAILED'
else:
	print 'test 1 passed'


# test -command gc via configure
teststatusok = None
obj = gctest1()
b = rivet.button(top)
b.bind('<1>', obj.callback, 1)
b.bind('<1>', None)
del obj
rivet.destroy(b)
if teststatusok == None:
	print 'test 2 FAILED'
else:
	print 'test 2 passed'


# test -command cleanup on object demise
teststatusok = None
obj = gctest1()
b = rivet.button(top)
b.configure(command=obj.callback)
del obj
rivet.destroy(b)
if teststatusok == None:
	print 'test 3 FAILED'
else:
	print 'test 3 passed'


# test -command gc via configure
teststatusok = None
obj = gctest1()
b = rivet.button(top)
b.configure(command=obj.callback)
b.configure(command=None)
del obj
rivet.destroy(b)
if teststatusok == None:
	print 'test 4 FAILED'
else:
	print 'test 4 passed'


# test gc within hierarchy
teststatusok = None
f = rivet.frame(top)
b = rivet.button(f)
del b
if len(f.children()) != 1:
	print 'test 5 FAILED'
else:
	print 'test 5 passed'
rivet.destroy(f)




