import rivet

t=rivet.init()

#####

test1 = 1
try:
	rivet.getvar('abc')
except:
	test1 = 0

#####

test2 = 0
def simplenotification():
	global test2
	test2 = test2 + 1
rivet.tracevar('abc', 'w', simplenotification)
rivet.setvar('abc', 'xyz')
rivet.untracevar('abc', 'w', simplenotification)
rivet.setvar('abc', 'querty')

#####

test3 = 1
test4 = 0
def notification2():
	global test4
	test4 = test4 + 1
	rivet.setvar('xxx', 'a new value')

rivet.tracevar('xxx', 'w', notification2)
rivet.setvar('xxx', 'overridden')
if rivet.getvar('xxx') == 'a new value':
	test3 = 0
rivet.untracevar('xxx', 'w', notification2)
rivet.setvar('xxx', 'ignored')
if rivet.getvar('xxx') != 'ignored':
	print 'test 3b FAILED'

#####

test5 = 1
class gcthing:
	def tracefun(self):
		pass

	def __del__(self):
		global test5
		test5 = 0
g=gcthing()
rivet.setvar('123', 'asdf')
rivet.tracevar('123', 'rw', g.tracefun)
rivet.untracevar('123', 'rw', g.tracefun) # this should clean up trace fn
rivet.unsetvar('123')
del g

#####

test6 = 1
class gcthing2:
	def tracefun(self):
		pass

	def __del__(self):
		global test6
		test6 = 0
g=gcthing2()
fun = g.tracefun
del g
rivet.setvar('qwerty', 'splat')
rivet.tracevar('qwerty', 'w', fun)
rivet.unsetvar('qwerty')  # in this case unsetvar will clean up
			  # internal refs to trace fn
test7=1
try:
	rivet.untracevar('qwerty', 'w', fun)
except:
	test7=0 # an exception should be generated because fun
		# has been removed by way of previous unsetvar
del fun


#####

if test1:
	print 'test1 FAILED'
if test2 != 1:
	print 'test2 FAILED'
if test3:
	print 'test3 FAILED'
if test4 != 1:
	print 'test4 FAILED'
if test5:
	print 'test5 FAILED'
if test6:
	print 'test6 FAILED'
if test7:
	print 'test7 FAILED'

print 'done'

