# example that creates most widget types and specifies some callbacks
# not pretty, but that's not the point.

import rivet, rivetutil

color = 'yellow'
def callback(obj):
	global color
	if color != 'yellow':
		color = 'yellow'
	else:
		color = 'blue'
	obj.configure(bg = color)

def goodbye():
	import sys
	print 'goodbye'
	sys.exit()

def canvas_cb(canvas):
	color2 = canvas.cget('bg')
	if(color2 == 'red'):
		color2 = 'orange'
	else:
		color2 = 'red'
	canvas.configure(bg=color2)


def do_canvas(parent):
	canvas = parent.canvas(
		width = 50,
		height = 50,
		bg = 'lightblue',
		bd = 2.0,
		relief = 'raised')
	canvas.create('oval', 10, 15, 40, 35, '-fill', 'green')
	canvas.tag_bind('1', '<1>', (canvas_cb, canvas))
	return canvas


def build_listbox(parent):
	global listboxw
	global fr
	global sb

	fr = parent.frame()
	listboxw = fr.listbox()
	sb = fr.scrollbar()

	listboxw.pack(side='left')
	sb.pack(side='right', fill='y')

	listboxw.insert(0, 
		'barend', 'headset', 'stem', 'fork', 'crank',
		'tire', 'bottom braket', 'shifter', 'handlebar',
		'stoppers', 'seatpost', 'frame', 'chain', 'cog')

	rivetutil.associate_scrollbar(listboxw, sb)

	return fr
 
def postcallback():
	print 'posting menu'

def menuentry_callback(newvalue):
	listboxw.configure(selectmode=newvalue)

def build_menu(parent):
	global mb
        mb = parent.menubutton()
	mb.configure(text='Listbox modes')

	menu = mb.menu(postcommand=postcallback)

	index = menu.add('command',
				label='single',
				command=(menuentry_callback, 'single'))
	index = menu.add('command',
				label='browse',
				command=(menuentry_callback, 'browse'))
	index = menu.add('command',
				label='extended',
				command=(menuentry_callback, 'extended'))
	index = menu.add('command',
				label='multiple',
				command=(menuentry_callback, 'multiple'))
	mb.configure(menu=menu)
	return mb

def buttoncallback():
	print 'button invoked'

def scalecallback(value):
	print 'scale set to', value

def scalecallback2(value, message):
	print message, value

def dummy5(mainw):
	fr1 = mainw.frame(
		bd=4,
		relief='raised')

	r1 = fr1.button(
		text='Button1',
		command=buttoncallback)
	r1.bind('<1>', (callback, r1))

	r2 = fr1.label(text='Label1')

	r5 = fr1.scale(command=scalecallback)

	r6 = fr1.scale(
		orient='horizontal',
		command=(scalecallback2, 'Horizontal scale set to') )


	r7 = do_canvas(fr1)

	r8 = fr1.entry()
	r9 = build_listbox(fr1)
	r10 = build_menu(fr1)
	r11 = fr1.message()
	r12 = fr1.text()
	r12.configure(width=20, height=4)

	rivet.pack(fr1, r1, r2, r5, r6, r7, r8, r9, r10, r11, r12)

	rivet.wm.protocol(mainw, "WM_DELETE_WINDOW", goodbye)


def run():
	top = rivet.init() # need args passed in 
	dummy5(top)
	rivet.mainloop()

if __name__ == '__main__':
	run()

