#include "rivet.h"

/* gack, this code was written hastily and probably has problems. */

/* consider making MenuAddOrInsert accessible outside tkMenu.c --
 * especially for assigning tags to menuitems.
 */
/* Consider making GetMenuIndex accessiable outside tkMenu.c and using
 * it here in place of awkward conversions - useful for $menu index $splat.
 */

/* Look out for default values for args... such as with tkPostOverPoint's entry.
 * (this may come from tkMenuFindName, which should return a code (-1) when
 * in the "none" case.) also look at tkMenuPost and tk_popup
 * tkMenuUnpost takes a null arg, check to see that passing zero wont dump.
 */

/*
 *--------------------------------------------------------------
 * Following code from menu.tcl.
 *--------------------------------------------------------------
 */

#define M_UP 0
#define M_DOWN 1 
#define M_LEFT 2
#define M_RIGHT 3
#define M_LR_NONE -1
 
static void rivet_menu_first_entry _ANSI_ARGS_((Rivetobj));
static void rivet_menu_post_over_point _ANSI_ARGS_((Rivetobj, int, int, int ));
static void rivet_save_grab_info _ANSI_ARGS_((Rivetobj));
EXTERN void rivet_tear_off_menu _ANSI_ARGS_((Rivetobj));

/* 
 * tkMbLeave --
 * This procedure is invoked when the mouse leaves a menubutton widget.
 * It de-activates the widget, if the widget still exists.
 *
 * Arguments:
 * w -			The  name of the widget.
 */ 
static int
rivet_mb_leave(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMbLeave w {
     global tkPriv
 
     set tkPriv(inMenubutton) {}
     if ![winfo exists $w] {
	return
     }
     if {[$w cget -state] == "active"} {
 	$w configure -state normal
     }
 }
#endif
	tkPriv->inMenubutton = 0;
	if (rivetobj->tkwin->flags & TK_ALREADY_DEAD) 
		return;
	if(rivet_state_p(rivetobj, "active"))
		rivet_state_set(rivetobj, "normal");
}

/* 
 * tkMbEnter --
 * This procedure is invoked when the mouse enters a menubutton
 * widget.  It activates the widget unless it is disabled.  Note:
 * this procedure is only invoked when mouse button 1 is *not* down.
 * The procedure tkMbB1Enter is invoked if the button is down.
 *
 * Arguments:
 * w -			The  name of the widget.
 */ 
static int
rivet_mb_enter(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMbEnter w {
     global tkPriv
 
     if {$tkPriv(inMenubutton) != ""} {
 	tkMbLeave $tkPriv(inMenubutton)
     }
     set tkPriv(inMenubutton) $w
     if {[$w cget -state] != "disabled"} {
 	$w configure -state active
     }
 }
#endif
	if(tkPriv->inMenubutton)
		rivet_mb_leave(tkPriv->inMenubutton, xevent, assoc);
	tkPriv->inMenubutton = rivetobj;
	if(!rivet_state_p(rivetobj, "disabled"))
		rivet_state_set(rivetobj, "active");
}

static Rivetobj
getmenu(menubutton)
	Rivetobj menubutton;
{
	Rivetobj menu;
	menu = rivet_path_to_rivetobj(
			rivet_get(menubutton, "-menu"));
	return menu; /* warning, may return NULL*/
}

static int
is_overrideredirect(menu)
	Rivetobj menu;
{
	int rv;

	if(!menu)
		return 0;

	rv = strtrue(rivet_va_func(menu, Tk_WmCmd,
				"overrideredirect", rivet_path(menu), 0));
	return rv;
}


/* 
 * tkMenuUnpost --
 * This procedure unposts a given menu, plus all of its ancestors up
 * to (and including) a menubutton, if any.  It also restores various
 * values to what they were before the menu was posted, and releases
 * a grab if there's a menubutton involved.  Special notes:
 * 1. It's important to unpost all menus before releasing the grab, so
 *    that any Enter-Leave events (e.g. from menu back to main
 *    application) have mode NotifyGrab.
 * 2. Be sure to enclose various groups of commands in "catch" so that
 *    the procedure will complete even if the menubutton or the menu
 *    or the grab window has been deleted.
 *
 * Arguments:
 * menu -		Name of a menu to unpost.  Ignored if there
 *			is a posted menubutton.
 */ 
static void
rivet_menu_unpost(menu)
	Rivetobj menu;
{
#if 0
 proc tkMenuUnpost menu {
     global tkPriv
     set mb $tkPriv(postedMb)
 
     # Restore focus right away (otherwise X will take focus away when
     # the menu is unmapped and under some window managers (e.g. olvwm)
     # we'll lose the focus completely).
 
     catch {focus $tkPriv(focus)}
     set tkPriv(focus) ""
 
     # Unpost menu(s) and restore some stuff that's dependent on
     # what was posted.
 
     catch {
 	if {$mb != ""} {
 	    set menu [$mb cget -menu]
 	    $menu unpost
 	    set tkPriv(postedMb) {}
 	    $mb configure -cursor $tkPriv(cursor)
 	    $mb configure -relief $tkPriv(relief)
 	} elseif {$tkPriv(popup) != ""} {
 	    $tkPriv(popup) unpost
 	    set tkPriv(popup) {}
 	} elseif {[wm overrideredirect $menu]} {
 	    # We're in a cascaded sub-menu from a torn-off menu or popup.
 	    # Unpost all the menus up to the toplevel one (but not
 	    # including the top-level torn-off one) and deactivate the
 	    # top-level torn off menu if there is one.
 
 	    while 1 {
 		set parent [winfo parent $menu]
 		if {([winfo class $parent] != "Menu")
 			|| ![winfo ismapped $parent]} {
 		    break
 		}
 		$parent activate none
 		$parent postcascade none
 		if {![wm overrideredirect $parent]} {
 		    break
 		}
 		set menu $parent
 	    }
 	    $menu unpost
 	}
     }
 
     # Release grab, if any, and restore the previous grab, if there
     # was one.
 
     if {$menu != ""} {
 	set grab [grab current $menu]
 	if {$grab != ""} {
 	    grab release $grab
 	}
     }
     if {$tkPriv(oldGrab) != ""} {
	if {$tkPriv(grabStatus) == "global"} {
	    grab set -global $tkPriv(oldGrab)
	} else {
	    grab set $tkPriv(oldGrab)
	}
    }
 }
#endif
	Rivetobj mb;
	Rivetobj parent;

	mb = tkPriv->postedMb;
	rivet_set_focus(tkPriv->focus);
	tkPriv->focus = 0;

	/* start catch */
	if(mb != 0) {
		menu = getmenu(mb);
		if(!menu)
			return;
		rivet_va_cmd(menu, "unpost", 0);
		tkPriv->postedMb = 0;
		rivet_set(mb, "-cursor", tkPriv->cursor);
		rivet_set(mb, "-relief", tkPriv->relief);
	} else if (tkPriv->popup != 0) {
		if(tkPriv->popup)
			rivet_va_cmd(tkPriv->popup, "unpost", 0);
		tkPriv->popup = 0;
	} else if(is_overrideredirect(menu)) {
		while (1) {
			parent = rivet_parent(menu);
			if(!parent ||
			   parent->rivet_class != MenuClass ||
			   !Tk_IsMapped(parent->tkwin))
				break;
			rivet_va_cmd(parent, "activate", "none", 0);
			rivet_va_cmd(parent, "postcascade", "none", 0);
			if(!is_overrideredirect(parent))
				break;
			menu = parent;
		}
		if(menu)
			rivet_va_cmd(menu, "unpost", 0);
	}
	/* end catch */

	if(menu != 0) {
		char * grab;
		grab = rivet_va_func(menu, Tk_GrabCmd,
						"current", rivet_path(menu), 0);
		if(!streq(grab, ""))
			rivet_va_func(menu, Tk_GrabCmd, "release", grab, 0);
	}

	if(tkPriv->oldGrab && tkPriv->oldGrab[0]) {
		if(tkPriv->grabStatus && streq(tkPriv->grabStatus, "global"))
			rivet_va_func(menu, Tk_GrabCmd,
				"set", "-global", tkPriv->oldGrab, 0);
		else
			rivet_va_func(menu, Tk_GrabCmd,
				"set", tkPriv->oldGrab, 0);
		free(tkPriv->oldGrab);
		tkPriv->oldGrab = 0;
	}
}

/* 
 * tkMbPost --
 * Given a menubutton, this procedure does all the work of posting
 * its associated menu and unposting any other menu that is currently
 * posted.
 *
 * Arguments:
 * w -			The name of the menubutton widget whose menu
 *			is to be posted.
 * x, y -		Root coordinates of cursor, used for positioning
 *			option menus.  If not specified, then the center
 *			of the menubutton is used for an option menu.
 */ 
static int
rivet_mb_post(rivetobj, xpos, ypos, use_root)
	Rivetobj rivetobj;
	int xpos, ypos;
	int use_root;
{
#if 0
 proc tkMbPost {w {x {}} {y {}}} {
     global tkPriv
     if {([$w cget -state] == "disabled") || ($w == $tkPriv(postedMb))} {
 	return
     }
     set menu [$w cget -menu]
     if {($menu == "") || ([$menu index last] == "none")} {
 	return
     }
     if ![string match $w.* $menu] {
 	error "can't post $menu:  it isn't a descendant of $w (this is a new requirement in Tk versions 3.0 and later)"
     }
     set cur $tkPriv(postedMb)
     if {$cur != ""} {
 	tkMenuUnpost {}
     }
     set tkPriv(cursor) [$w cget -cursor]
     set tkPriv(relief) [$w cget -relief]
     $w configure -cursor arrow
     $w configure -relief raised
     set tkPriv(postedMb) $w
     set tkPriv(focus) [focus]
     $menu activate none
 
     # If this looks like an option menubutton then post the menu so
     # that the current entry is on top of the mouse.  Otherwise post
     # the menu just below the menubutton, as for a pull-down.
 
     if {([$w cget -indicatoron] == 1) && ([$w cget -textvariable] != "")} {
 	if {$y == ""} {
 	    set x [expr [winfo rootx $w] + [winfo width $w]/2]
 	    set y [expr [winfo rooty $w] + [winfo height $w]/2]
 	}
 	tkPostOverPoint $menu $x $y [tkMenuFindName $menu [$w cget -text]]
     } else {
 	$menu post [winfo rootx $w] [expr [winfo rooty $w]+[winfo height $w]]
     }
     focus $menu
     tkSaveGrabInfo $w
     grab -global $w
 }
#endif
	int x, y;
	int x2, y2;
	Rivetobj menu;
	Rivetobj cur;

	if(rivet_state_p(rivetobj, "disabled") || (rivetobj==tkPriv->postedMb))
		return;
	menu = getmenu(rivetobj);
	if((menu == 0) || streq(rivet_va_cmd(menu, "index", "last", 0), "none"))
		return;
	if(strncmp(rivet_path(rivetobj), rivet_path(menu),
						strlen(rivet_path(rivetobj)))) {
		printf("Cannot post menu (%s): it is not a child of (%s).\n",
			rivet_path(rivetobj), rivet_path(menu));
		return;
	}
	cur = tkPriv->postedMb;
	if(cur != 0)
		rivet_menu_unpost(0);
	strcpy(tkPriv->cursor, rivet_get(rivetobj, "-cursor"));
	strcpy(tkPriv->relief, rivet_get(rivetobj, "-relief"));
	rivet_set(rivetobj, "-cursor", "arrow");
	rivet_set(rivetobj, "-relief", "raised");
	tkPriv->postedMb = rivetobj;
	tkPriv->focus = rivet_get_focus(rivetobj);
	rivet_va_cmd(menu, "activate", "none", 0);

	if(strtrue(rivet_get(rivetobj, "-indicatoron")) &&
	  (!streq(rivet_get(rivetobj, "-textvariable"), ""))) {
		if(use_root) {
			Tk_GetRootCoords((Tk_Window)rivetobj->tkwin, &x2, &y2);
			xpos = x2 + Tk_Width(rivetobj->tkwin)/2;
			ypos = y2 + Tk_Height(rivetobj->tkwin)/2;
		}
		rivet_menu_post_over_point(menu, xpos, ypos,
		  rivet_menu_find_name(menu, rivet_get(rivetobj, "-text")));
	} else {
		Tk_GetRootCoords((Tk_Window)rivetobj->tkwin, &x2, &y2);
		rivet_va_cmd(menu, "post", rivet_itoa(x2),
			rivet_itoa(y2+Tk_Height(rivetobj->tkwin)), 0);
	}
	rivet_set_focus(menu);
	rivet_save_grab_info(rivetobj);
	Tk_Grab(rivetobj->interp, (Tk_Window)rivetobj->tkwin, 1);
}



/* 
 * tkMbMotion --
 * This procedure handles mouse motion events inside menubuttons, and
 * also outside menubuttons when a menubutton has a grab (e.g. when a
 * menu selection operation is in progress).
 *
 * Arguments:
 * w -			The name of the menubutton widget.
 * upDown - 		"down" means button 1 is pressed, "up" means
 *			it isn't.
 * rootx, rooty -	Coordinates of mouse, in (virtual?) root window.
 */ 
static int
rivet_mb_motion(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMbMotion {w upDown rootx rooty} {
     global tkPriv
 
     if {$tkPriv(inMenubutton) == $w} {
 	return
     }
     set new [winfo containing $rootx $rooty]
     if {($new != $tkPriv(inMenubutton)) && (($new == "")
             || ([winfo toplevel $new] == [winfo toplevel $w]))} {
 	if {$tkPriv(inMenubutton) != ""} {
 	    tkMbLeave $tkPriv(inMenubutton)
 	}
 	if {($new != "") && ([winfo class $new] == "Menubutton")
 		&& ([$new cget -indicatoron] == 0)} {
 	    if {$upDown == "down"} {
 		tkMbPost $new $rootx $rooty
 	    } else {
 		tkMbEnter $new
 	    }
 	}
     }
 }
#endif
	int rootx, rooty;
	Rivetobj new;

	if(tkPriv->inMenubutton == rivetobj)
		return;

	rivet_rootcoords(rivetobj, xevent, &rootx, &rooty);
	new = rivet_path_to_rivetobj(
		rivet_va_func(rivetobj, Tk_WinfoCmd, "containing",
			rivet_itoa(rootx), rivet_itoa(rooty), 0));
	if((new != tkPriv->inMenubutton) && ((new == 0)
	    || rivet_to_toplevel(new) == rivet_to_toplevel(rivetobj))) {
	    if(tkPriv->inMenubutton != 0)
		rivet_mb_leave(tkPriv->inMenubutton);
	    if((new != 0) && (new->rivet_class == MenubuttonClass) &&
		(strfalse(rivet_get(new, "-indicatoron")))) {
		if((int)assoc == M_DOWN)
			rivet_mb_post(new, rootx, rooty, 0);
		else
			rivet_mb_enter(new);
	    }
	}
}
 
/*
 * tkMbButtonUp --
 * This procedure is invoked to handle button 1 releases for menubuttons.
 * If the release happens inside the menubutton then leave its menu
 * posted with element 0 activated.  Otherwise, unpost the menu.
 *
 * Arguments:
 * w -			The name of the menubutton widget.
 */
static int
rivet_mb_button_up(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMbButtonUp w {
     global tkPriv
 
     if  {($tkPriv(postedMb) == $w) && ($tkPriv(inMenubutton) == $w)} {
 	tkMenuFirstEntry [$tkPriv(postedMb) cget -menu]
     } else {
 	tkMenuUnpost {}
     }
 }
#endif

	if((tkPriv->postedMb == rivetobj) && (tkPriv->inMenubutton == rivetobj))
		rivet_menu_first_entry(
			rivet_path_to_rivetobj(
				rivet_get(tkPriv->postedMb, "-menu")));
	else
		rivet_menu_unpost(0);
}

/* 
 * tkMenuMotion --
 * This procedure is called to handle mouse motion events for menus.
 * It does two things.  First, it resets the active element in the
 * menu, if the mouse is over the menu.  Second, if a mouse button
 * is down, it posts and unposts cascade entries to match the mouse
 * position.
 *
 * Arguments:
 * menu -		The menu window.
 * y -			The y position of the mouse.
 * state -		Modifier state (tells whether buttons are down).
 */ 
static int
rivet_menu_motion(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuMotion {menu y state} {
     global tkPriv
     if {$menu == $tkPriv(window)} {
 	$menu activate @$y
     }
     if {($state & 0x1f00) != 0} {
 	$menu postcascade active
     }
 }
#endif
	int state;
	char buf[20];

	if(rivetobj == tkPriv->window) {
		sprintf(buf, "@%d", ((XMotionEvent*)xevent)->y);
		rivet_va_cmd(rivetobj, "activate", buf, 0);
	}
	if((xevent->xkey.state & 0x1f00) != 0)
		rivet_va_cmd(rivetobj, "postcascade", "active", 0);
}

/* 
 * tkMenuButtonDown --
 * Handles button presses in menus.  There are a couple of tricky things
 * here:
 * 1. Change the posted cascade entry (if any) to match the mouse position.
 * 2. If there is a posted menubutton, must grab to the menubutton;  this
 *    overrrides the implicit grab on button press, so that the menu
 *    button can track mouse motions over other menubuttons and change
 *    the posted menu.
 * 3. If there's no posted menubutton (e.g. because we're a torn-off menu
 *    or one of its descendants) must grab to the top-level menu so that
 *    we can track mouse motions across the entire menu hierarchy.
 *
 * Arguments:
 * menu -		The menu window.
 */ 
static int
rivet_menu_button_down(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuButtonDown menu {
     global tkPriv
     $menu postcascade active
     if {$tkPriv(postedMb) != ""} {
 	grab -global $tkPriv(postedMb)
     } else {
 	while {[wm overrideredirect $menu]
 		&& ([winfo class [winfo parent $menu]] == "Menu")
 		&& [winfo ismapped [winfo parent $menu]]} {
 	    set menu [winfo parent $menu]
 	}
	tkSaveGrabInfo $menu
 	grab -global $menu
     }
 }
#endif
	Rivetobj menu;

	menu = rivetobj;

	rivet_va_cmd(menu, "postcascade", "active", 0);
	if (tkPriv->postedMb != 0)
		Tk_Grab(menu->interp, (Tk_Window) tkPriv->postedMb->tkwin, 1);
	else {
		while(is_overrideredirect(menu) &&
			rivet_parent(menu) &&
			(rivet_parent(menu)->rivet_class == MenuClass) &&
			Tk_IsMapped(rivet_parent(menu)->tkwin))
				menu = rivet_parent(menu);
		rivet_save_grab_info(menu);
		Tk_Grab(menu->interp, (Tk_Window) tkPriv->postedMb->tkwin, 1);
	}
}

/* 
 * tkMenuLeave --
 * This procedure is invoked to handle Leave events for a menu.  It
 * deactivates everything unless the active element is a cascade element
 * and the mouse is now over the submenu.
 *
 * Arguments:
 * menu -		The menu window.
 * rootx, rooty -	Root coordinates of mouse.
 * state -		Modifier state.
 */ 
static int
rivet_menu_leave(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuLeave {menu rootx rooty state} {
     global tkPriv
     set tkPriv(window) {}
     if {[$menu index active] == "none"} {
 	return
     }
     if {([$menu type active] == "cascade")
 	    && ([winfo containing $rootx $rooty]
 	    == [$menu entrycget active -menu])} {
 	return
     }
     $menu activate none
 }
#endif
	Rivetobj menu;
	int rootx, rooty;
	menu = rivetobj;

	tkPriv->window = 0;
	if(streq(rivet_va_cmd(menu, "index", "active",0), "none"))
		return;
	if(streq(rivet_va_cmd(menu, "type", "active",0), "cascade")) {
		rivet_rootcoords(menu, xevent, &rootx, &rooty);
		if(streq(
			rivet_va_func(menu, Tk_WinfoCmd, "containing",
				rivet_itoa(rootx), rivet_itoa(rooty), 0),
			rivet_va_cmd(menu, "entrycget", "active", "-menu", 0)))
		return;
	}
	rivet_va_cmd(menu, "activate", "none", 0);
}

/* 
 * tkMenuInvoke --
 * This procedure is invoked when button 1 is released over a menu.
 * It invokes the appropriate menu action and unposts the menu if
 * it came from a menubutton.
 *
 * Arguments:
 * w -			Name of the menu widget.
 */ 
static int
rivet_menu_invoke(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuInvoke w {
     if {[$w type active] == "cascade"} {
 	$w postcascade active
 	set menu [$w entrycget active -menu]
 	tkMenuFirstEntry $menu
     } elseif {[$w type active] == "tearoff"} {
 	tkMenuUnpost $w
 	tkTearOffMenu $w
     } else {
 	tkMenuUnpost $w
	uplevel #0 [list $w invoke active]
     }
 }
#endif
	char *typeactive;

	typeactive = rivet_va_cmd(rivetobj, "type", "active", 0);

	if(streq(typeactive, "cascade")) {
		Rivetobj menu;
		rivet_va_cmd(rivetobj, "postcascade", "active", 0);
		menu = rivet_path_to_rivetobj(
		    rivet_va_cmd(rivetobj, "entrycget", "active", "-menu", 0));
		rivet_menu_first_entry(menu);
	} else
	if(streq(typeactive, "tearoff")) {
		rivet_menu_unpost(rivetobj);
		rivet_tear_off_menu(rivetobj);
	} else {
		rivet_menu_unpost(rivetobj);
		rivet_va_cmd(rivetobj, "invoke", "active", 0);
	}
}

/* 
 * tkMenuEscape --
 * This procedure is invoked for the Cancel (or Escape) key.  It unposts
 * the given menu and, if it is the top-level menu for a menu button,
 * unposts the menu button as well.
 *
 * Arguments:
 * menu -		Name of the menu window.
 */ 
static int
rivet_menu_escape(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuEscape menu {
     if {[winfo class [winfo parent $menu]] != "Menu"} {
 	tkMenuUnpost $menu
     } else {
 	tkMenuLeftRight $menu -1
     }
 }
#endif
	if(rivetobj->rivet_class != MenuClass)
		rivet_menu_unpost(rivetobj);
	else
		rivet_menu_left_right(rivetobj, xevent, M_LR_NONE);
}

/* 
 * tkMenuLeftRight --
 * This procedure is invoked to handle "left" and "right" traversal
 * motions in menus.  It traverses to the next menu in a menu bar,
 * or into or out of a cascaded menu.
 *
 * Arguments:
 * menu -		The menu that received the keyboard
 *			event.
 * direction -		Direction in which to move: "left" or "right"
 */ 
static int
rivet_menu_left_right(rivetobj, xevent, assoc) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
 proc tkMenuLeftRight {menu direction} {
     global tkPriv
 
     # First handle traversals into and out of cascaded menus.
 
     if {$direction == "right"} {
 	set count 1
 	if {[$menu type active] == "cascade"} {
 	    $menu postcascade active
 	    set m2 [$menu entrycget active -menu]
 	    if {$m2 != ""} {
 		tkMenuFirstEntry $m2
 	    }
 	    return
 	}
     } else {
 	set count -1
 	set m2 [winfo parent $menu]
 	if {[winfo class $m2] == "Menu"} {
 	    $menu activate none
 	    focus $m2
 
 	    # This code unposts any posted submenu in the parent.
 
 	    set tmp [$m2 index active]
 	    $m2 activate none
 	    $m2 activate $tmp
 	    return
 	}
     }
 
     # Can't traverse into or out of a cascaded menu.  Go to the next
     # or previous menubutton, if that makes sense.
 
     set w $tkPriv(postedMb)
     if {$w == ""} {
 	return
     }
     set buttons [winfo children [winfo parent $w]]
     set length [llength $buttons]
     set i [expr [lsearch -exact $buttons $w] + $count]
     while 1 {
 	while {$i < 0} {
 	    incr i $length
 	}
 	while {$i >= $length} {
 	    incr i -$length
 	}
 	set mb [lindex $buttons $i]
 	if {([winfo class $mb] == "Menubutton")
 		&& ([$mb cget -state] != "disabled")
 		&& ([$mb cget -menu] != "")
 		&& ([[$mb cget -menu] index last] != "none")} {
 	    break
 	}
 	if {$mb == $w} {
 	    return
 	}
 	incr i $count
     }
     tkMbPost $mb
     tkMenuFirstEntry [$mb cget -menu]
 }
#endif
	int length;
	int count, i, j;
	Rivetobj menu;
	Rivetobj m2;
	Rivetobj w;
	TkWindow *buttons, *btmp, *mb;
	char *tmpmenu;
 
	menu = rivetobj;

        /*First handle traversals into and out of cascaded menus.*/
	if((int)assoc == M_RIGHT) {
 	  count = 1;
 	  if (streq(rivet_va_cmd(menu, "type", "active", 0), "cascade")) {
		rivet_va_cmd(menu, "postcascade", "active", 0);
		m2 = rivet_path_to_rivetobj(
			rivet_va_cmd(menu, "entrycget", "active", "-menu", 0));
		if(m2)
			rivet_menu_first_entry(m2);
		return;
	  }
	} else {
	  count = -1;
	  m2 = rivet_parent(menu);
 	  if (m2->rivet_class == MenuClass) {
		char *tmp;
		rivet_va_cmd(menu, "activate", "none", 0);
		rivet_set_focus(m2);
		/*This code unposts any posted submenu in the parent.*/
		tmp = rivet_va_cmd(m2, "index", "active", 0);
		rivet_va_cmd(m2, "activate", "none", 0); 
		rivet_va_cmd(m2, "activate", tmp, 0); 
		return;
	  }
	}

	/*
	 * Can't traverse into or out of a cascaded menu.  Go to the next
	 * or previous menubutton, if that makes sense.
	 */ 
	w = tkPriv->postedMb;
	if(!w)
		return;
	/*set buttons [winfo children [winfo parent $w]]*/
	buttons = rivet_parent(w)->tkwin->childList;
	if(!buttons)
		return;
	/*set length [llength $buttons]*/
	for(length=0, btmp=buttons; btmp; length++, btmp=btmp->nextPtr) ;

	/*set i [expr [lsearch -exact $buttons $w] + $count]*/
	for(i=0, btmp=buttons; btmp != w->tkwin; i++, btmp=btmp->nextPtr) ;
	i += count;

	while(1) {
		while(i < 0) i += length;
 		while(i >= length) i -= length;

 		/*set mb [lindex $buttons $i]*/
		for(mb=buttons, j=0; j<i; mb=mb->nextPtr, j++) ;

		tmpmenu = rivet_get(mb->rivetobj, "-menu");
		if((mb->rivetobj->rivet_class == MenubuttonClass) &&
		   (!rivet_state_p(mb->rivetobj, "disabled")) &&
		   (!streq(tmpmenu, "")) &&
		   (!streq(
				rivet_va_cmd(rivet_path_to_rivetobj(tmpmenu), "index", "last", 0),
				"none")))
			break;

		if(mb->rivetobj == w)
			return;

		i += count;
	}
	rivet_mb_post(mb->rivetobj, 0, 0, 1);
	rivet_menu_first_entry(
		rivet_path_to_rivetobj(
			rivet_get(mb->rivetobj, "-menu")));
}

/* 
 * tkMenuNextEntry --
 * Activate the next higher or lower entry in the posted menu,
 * wrapping around at the ends.  Disabled entries are skipped.
 *
 * Arguments:
 * menu -			Menu window that received the keystroke.
 * count -			1 means go to the next lower entry,
 *				-1 means go to the next higher entry.
 */ 
static int
rivet_menu_next_entry(rivetobj, xevent, count_in) 
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData count_in;
{
#if 0
 proc tkMenuNextEntry {menu count} {
     global tkPriv
     if {[$menu index last] == "none"} {
 	return
     }
     set length [expr [$menu index last]+1]
     set active [$menu index active]
     if {$active == "none"} {
 	set i 0
     } else {
 	set i [expr $active + $count]
     }
     while 1 {
 	while {$i < 0} {
 	    incr i $length
 	}
 	while {$i >= $length} {
 	    incr i -$length
 	}
 	if {[catch {$menu entrycget $i -state} state] == 0} {
 	    if {$state != "disabled"} {
 		break
 	    }
 	}
 	if {$i == $active} {
 	    return
 	}
 	incr i $count
     }
     $menu activate $i
     $menu postcascade $i
 }
#endif
	Rivetobj menu;
	int length;
	int i;
	char *active;
	int active_n;
	char *state;
	int count = (int) count_in;

	menu = rivetobj;

	if(streq(rivet_va_cmd(menu, "index", "last", 0), "none"))
		return;
	length = rivet_va_cmd_int(menu, "index", "last", 0) + 1;
	active = rivet_va_cmd(menu, "index", "active", 0);
	if(streq(active, "none"))
		i = 0;
	else
		i = atoi(active) + count;

	while(1) {
		while(i<0) i += length;
		while(i>=length) i -= length;

		/* catch */
		state = rivet_va_cmd(menu, "entrycget",
				rivet_itoa(i), "-state", 0);
		if(streq(state, "disabled"))
			break;
		if(i == atoi(active))
			return;
		i += count;
	}
	rivet_va_cmd(menu, "activate", rivet_itoa(i), 0);
	rivet_va_cmd(menu, "postcascade", rivet_itoa(i), 0);
}

/* 
 * tkMenuFind --
 * This procedure searches the entire window hierarchy under w for
 * a menubutton that isn't disabled and whose underlined character
 * is "char".  It returns the name of that window, if found, or an
 * empty string if no matching window was found.  If "char" is an
 * empty string then the procedure returns the name of the first
 * menubutton found that isn't disabled.
 *
 * Arguments:
 * w -				Name of window where key was typed.
 * char -			Underlined character to search for;
 *				may be either upper or lower case, and
 *				will match either upper or lower case.
 */ 
static Rivetobj
rivet_menu_find(rivetobj, char_in) 
	Rivetobj rivetobj;
	char *char_in;
{
#if 0
 proc tkMenuFind {w char} {
     global tkPriv
     set char [string tolower $char]
 
     foreach child [winfo child $w] {
 	switch [winfo class $child] {
 	    Menubutton {
 		set char2 [string index [$child cget -text] \
 			[$child cget -underline]]
 		if {([string compare $char [string tolower $char2]] == 0)
 			|| ($char == "")} {
 		    if {[$child cget -state] != "disabled"} {
 			return $child
 		    }
 		}
 	    }
 	    Frame {
 		set match [tkMenuFind $child $char]
 		if {$match != ""} {
 		    return $match
 		}
 	    }
 	}
     }
     return {}
 }
#endif

	Rivetobj w, match;
	TkWindow *childp;
	char char1[80];
	char char2[2];
	char *tmp;
	int i;

	w = rivetobj;

	if(!char_in)
		return 0;

	strncpy(char1, char_in, sizeof(char1));
	for(tmp=char1;*tmp;tmp++) *tmp = tolower(*tmp);

	for(childp = w->tkwin->childList; childp; childp = childp->nextPtr) {
		if(childp->rivetobj->rivet_class == MenubuttonClass) {
			tmp = rivet_get(childp->rivetobj, "-text");
			i = rivet_get_int(childp->rivetobj, "-underline");
			if(i > (int)strlen(tmp))
				return 0;
			char2[0] = tolower(tmp[i]);
			char2[1] = 0;
			if(streq(char2, char1) || char1[0] == 0) {
				if(!rivet_state_p(childp->rivetobj, "disabled"))
					return childp->rivetobj;
			}
		} else
		if(childp->rivetobj->rivet_class == FrameClass) {
			match = rivet_menu_find(childp->rivetobj, char_in);
			if(match != 0)
				return match;
			break;
		}
	}
	return 0;
}

/* 
 * tkTraverseToMenu --
 * This procedure implements keyboard traversal of menus.  Given an
 * ASCII character "char", it looks for a menubutton with that character
 * underlined.  If one is found, it posts the menubutton's menu
 *
 * Arguments:
 * w -				Window in which the key was typed (selects
 *				a toplevel window).
 * char -			Character that selects a menu.  The case
 *				is ignored.  If an empty string, nothing
 *				happens.
 */ 
static int
rivet_menu_traverse_to_menu(w, xevent, unused1, unused2) 
	Rivetobj w;
	XEvent *xevent;
	ClientData unused1;
	int unused2;
{
#if 0
 proc tkTraverseToMenu {w char} {
     if {$char == ""} {
 	return
     }
     while {[winfo class $w] == "Menu"} {
	set w [winfo parent $w]
     }
     set w [tkMenuFind [winfo toplevel $w] $char]
     if {$w != ""} {
 	tkMbPost $w
 	tkMenuFirstEntry [$w cget -menu]
     }
 }
#endif
	char *char_in;

	char_in = rivet_input_str(w, xevent);
	if (!char_in || char_in[0] == 0)
		return;
	while(w->rivet_class == MenuClass)
		w = rivet_parent(w);
	w = rivet_menu_find(rivet_to_toplevel(w) , char_in);
	if(w) {
		rivet_mb_post(w, 0, 0, 1);
		rivet_menu_first_entry(
			rivet_path_to_rivetobj(
				rivet_get(w, "-menu")));
	}
	return TCL_CONTINUE;
}


/* 
 * tkFirstMenu --
 * This procedure traverses to the first menubutton in the toplevel
 * for a given window, and posts that menubutton's menu.
 *
 * Arguments:
 * w -				Name of a window.  Selects which toplevel
 *				to search for menubuttons.
 */ 
static int
rivet_menu_first_menu(rivetobj, xevent, unused1, unused2)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData unused1;
	int unused2;
{
#if 0
 proc tkFirstMenu w {
     set w [tkMenuFind [winfo toplevel $w] ""]
     if {$w != ""} {
 	tkMbPost $w
 	tkMenuFirstEntry [$w cget -menu]
     }
 }
#endif
	Rivetobj w;
	w = rivet_menu_find(rivet_to_toplevel(rivetobj) , "");
	if(w) {
		rivet_mb_post(w, 0, 0, 1);
		rivet_menu_first_entry(
			rivet_path_to_rivetobj(
				rivet_get(w, "-menu")));
	}
	return TCL_CONTINUE;
}

/* 
 * tkTraverseWithinMenu
 * This procedure implements keyboard traversal within a menu.  It
 * searches for an entry in the menu that has "char" underlined.  If
 * such an entry is found, it is invoked and the menu is unposted.
 *
 * Arguments:
 * w -				The name of the menu widget.
 * char -			The character to look for;  case is
 *				ignored.  If the string is empty then
 *				nothing happens.
 */ 
static int
rivet_menu_traverse_within_menu(rivetobj, xevent, unused1, unused2)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData unused1;
	int unused2;
{
#if 0
 proc tkTraverseWithinMenu {w char} {
     if {$char == ""} {
 	return
     }
     set char [string tolower $char]
     set last [$w index last]
     if {$last == "none"} {
 	return
     }
     for {set i 0} {$i <= $last} {incr i} {
 	if [catch {set char2 [string index \
 		[$w entrycget $i -label] \
 		[$w entrycget $i -underline]]}] {
 	    continue
 	}
 	if {[string compare $char [string tolower $char2]] == 0} {
 	    if {[$w type $i] == "cascade"} {
 		$w postcascade $i
 		$w activate $i
 		set m2 [$w entrycget $i -menu]
 		if {$m2 != ""} {
 		    tkMenuFirstEntry $m2
 		}
 	    } else {
 		tkMenuUnpost $w
 		uplevel #0 [list $w invoke $i]
 	    }
 	    return
 	}
     }
 }
#endif
	Rivetobj w;
	char char1[80];
	char char2[2];
	char *tmp;
	int last;
	int i;
	int j;
	char *i_str;
	char *m2;
	char *char_;

	w = rivetobj;

	char_ = rivet_input_str(w, xevent);
	if(!char_ || char_[0] == 0)
		return TCL_CONTINUE;

	strncpy(char1, char_, sizeof(char1));
	for(tmp=char1;*tmp;tmp++) *tmp = tolower(*tmp);
	tmp = rivet_va_cmd(w, "index", "last", 0);
	if (streq(tmp, "none"))
		return TCL_CONTINUE;
	last = atoi(tmp);
	for (i=0; i<=last; i++) {
		i_str = rivet_itoa(i);
		tmp = rivet_va_cmd(w, "entrycget", i_str, "-label", 0);
		if(rivet_error_occured) continue;
		j = rivet_va_cmd_int(w, "entrycget", i_str, "-underline", 0);
		if(rivet_error_occured) continue;
		char2[0] = tolower(tmp[j]);
		char2[1] =0;

		if(streq(char1, char2)) {
		    if(streq(rivet_va_cmd(w, "type", i_str, 0), "cascade")) {
			rivet_va_cmd(w, "postcascade", i_str, 0);
			rivet_va_cmd(w, "activate", i_str, 0);
			m2 = rivet_va_cmd(w, "entrycget", i_str, "-menu", 0);
			if(m2 && m2[0] != 0)
				rivet_menu_first_entry(
					rivet_path_to_rivetobj(m2));
		    } else {
			rivet_menu_unpost(w);
			rivet_va_cmd(w, "invoke", i_str, 0);
		    }
		}
		return TCL_CONTINUE;
	}
	return TCL_CONTINUE;
}

/* 
 * tkMenuFirstEntry --
 * Given a menu, this procedure finds the first entry that isn't
 * disabled or a tear-off or separator, and activates that entry.
 * However, if there is already an active entry in the menu (e.g.,
 * because of a previous call to tkPostOverPoint) then the active
 * entry isn't changed.  This procedure also sets the input focus
 * to the menu.
 *
 * Arguments:
 * menu -		Name of the menu window (possibly empty).
 */ 
static void
rivet_menu_first_entry(rivetobj) 
	Rivetobj rivetobj;
{
#if 0
 proc tkMenuFirstEntry menu {
     if {$menu == ""} {
 	return
     }
     focus $menu
     if {[$menu index active] != "none"} {
 	return
     }
     set last [$menu index last]
     if {$last == "none"} {
 	return
     }
     for {set i 0} {$i <= $last} {incr i} {
 	if {([catch {set state [$menu entrycget $i -state]}] == 0)
 		&& ($state != "disabled") && ([$menu type $i] != "tearoff")} {
 	    $menu activate $i
 	    return
 	}
     }
 }
#endif
	int i;
	char *i_str;
	int last;
	char *last_str;
	char *state;

	if(!rivetobj)
		return;
	rivet_set_focus(rivetobj);
	if(!streq(rivet_va_cmd(rivetobj, "index", "active", 0), "none"))
		return;

	last_str = rivet_va_cmd(rivetobj, "index", "last", 0);
	if(streq(last_str, "none"))
		return;
	last = atoi(last_str);

	for(i=0; i<=last; i++) {
		i_str = rivet_itoa(i);
		state = rivet_va_cmd(rivetobj, "entrycget", i_str, "-state", 0);
		if(rivet_error_occured) continue;
		if(!streq(state, "disabled")) continue;
		if(!streq(rivet_va_cmd(rivetobj, "type", i_str, 0), "tearoff")){
			rivet_va_cmd(rivetobj, "activate", i_str, 0);
			return;
		}
	}
}

/* 
 * tkMenuFindName --
 * Given a menu and a text string, return the index of the menu entry
 * that displays the string as its label.  If there is no such entry,
 * return an empty string.  This procedure is tricky because some names
 * like "active" have a special meaning in menu commands, so we can't
 * always use the "index" widget command.
 *
 * Arguments:
 * menu -		Name of the menu widget.
 * s -			String to look for.
 */ 
static int
rivet_menu_find_name(menu, str)
	Rivetobj menu;
	char *str;
{
#if 0
 proc tkMenuFindName {menu s} {
     set i ""
     if {![regexp {^active$|^last$|^none$|^[0-9]|^@} $s]} {
 	catch {set i [$menu index $s]}
 	return $i
     }
     set last [$menu index last]
     if {$last == "none"} {
 	return
     }
     for {set i 0} {$i <= $last} {incr i} {
 	if ![catch {$menu entrycget $i -label} label] {
 	    if {$label == $s} {
 		return $i
 	    }
 	}
     }
     return ""
 }
#endif

/* just implement the loop, forget the quick and dirty regexp. */

	char *last_str;
	int last;
	int *i_str;
	int i;
	char *label;
	char searchfor[200];

	strncpy(searchfor, str, sizeof(searchfor));
	last_str = rivet_va_cmd(menu, "index", "last", 0);
	if(streq(last_str, "none"))
		return -1;
	last = atoi(last_str);
	for (i=0; i<=last; i++) {
		label = rivet_va_cmd(menu,
				"entrycget", rivet_itoa(i), "-label", 0);
		if(rivet_error_occured)
			continue;
		if(streq(label, searchfor))
			return i;
	}
	return -1;
}

/* 
 * tkPostOverPoint --
 * This procedure posts a given menu such that a given entry in the
 * menu is centered over a given point in the root window.  It also
 * activates the given entry.
 *
 * Arguments:
 * menu -		Menu to post.
 * x, y -		Root coordinates of point.
 * entry -		Index of entry within menu to center over (x,y).
 *			If omitted or specified as {}, then the menu's
 *			upper-left corner goes at (x,y).
 */ 
static void
rivet_menu_post_over_point(menu, x, y, entry)
	Rivetobj menu;
	int x;
	int y;
	int entry;
{
#if 0
 proc tkPostOverPoint {menu x y {entry {}}}  {
     if {$entry != {}} {
 	if {$entry == [$menu index last]} {
 	    incr y [expr -([$menu yposition $entry] \
		    + [winfo reqheight $menu])/2]

 	} else {
 	    incr y [expr -([$menu yposition $entry] \
 		    + [$menu yposition [expr $entry+1]])/2]
 	}
 	incr x [expr -[winfo reqwidth $menu]/2]
     }
     $menu post $x $y
     if {($entry != {}) && ([$menu entrycget $entry -state] != "disabled")} {
 	$menu activate $entry
     }
 }
#endif
	int tmp;
	char *tmp_str;

	if(entry != -1) {
	    tmp_str = rivet_itoa(entry);
	    tmp = rivet_va_cmd_int(menu, "yposition", tmp_str, 0);

	    if(streq(tmp_str, rivet_va_cmd(menu, "index", "last", 0)))
		y -= (tmp + Tk_ReqHeight(menu->tkwin))/2;
	    else
		y -= (tmp + rivet_va_cmd_int(menu, "yposition",
			rivet_itoa(entry+1)))/2;
	    x -= Tk_ReqWidth(menu->tkwin)/2;
	}
	rivet_va_cmd(menu, "post", rivet_itoa(x), rivet_itoa(y), 0);
	if((entry != -1) && !streq(
		rivet_va_cmd(menu, "entrycget", rivet_itoa(entry), "-state", 0),
		"disabled"))
		rivet_va_cmd(menu, "activate", rivet_itoa(entry), 0);
}

/* tkSaveGrabInfo --
 * Sets the variables tkPriv(oldGrab) and tkPriv(grabStatus) to record
 * the state of any existing grab on the w's display.
 *
 * Arguments:
 * w -			Name of a window;  used to select the display
 *			whose grab information is to be recorded.
 */
static void
rivet_save_grab_info(w)
	Rivetobj w;
{
#if 0
 proc tkSaveGrabInfo w {
    global tkPriv
    set tkPriv(oldGrab) [grab current $w]
    if {$tkPriv(oldGrab) != ""} {
        set tkPriv(grabStatus) [grab status $tkPriv(oldGrab)]
    }
 }
#endif
	char *current;

	if(tkPriv->oldGrab) {
		free(tkPriv->oldGrab);
		tkPriv->oldGrab = 0;
	}
	current = rivet_va_func(w, Tk_GrabCmd, "current", rivet_path(w), 0);
	if(current && current[0]) {
		tkPriv->oldGrab = strdup(current);
		if(tkPriv->grabStatus)
			free(tkPriv->grabStatus);
		tkPriv->grabStatus = strdup( rivet_va_func(w,
			Tk_GrabCmd, "status", tkPriv->oldGrab, 0));
	}
}

/* 
 * tk_popup --
 * This procedure pops up a menu and sets things up for traversing
 * the menu and its submenus.
 *
 * Arguments:
 * menu -		Name of the menu to be popped up.
 * x, y -		Root coordinates at which to pop up the
 *			menu.
 * entry -		Index of a menu entry to center over (x,y).
 *			If omitted or specified as {}, then menu's
 *			upper-left corner goes at (x,y).
 */ 
void
rivet_popup(menu, x, y, entry)
	Rivetobj menu;
	int x;
	int y;
	int entry;
{
#if 0
 proc tk_popup {menu x y {entry {}}} {
     global tkPriv
     if {($tkPriv(popup) != "") || ($tkPriv(postedMb) != "")} {
 	tkMenuUnpost {}
     }
     tkPostOverPoint $menu $x $y $entry
     tkSaveGrabInfo $menu
     grab -global $menu
     set tkPriv(popup) $menu
     set tkPriv(focus) [focus]
     focus $menu
 }
#endif

	if(tkPriv->popup || tkPriv->postedMb)
		rivet_menu_unpost(0);
	rivet_menu_post_over_point(menu, x, y, entry);
	rivet_save_grab_info(menu);
	Tk_Grab(menu->interp, (Tk_Window)menu->tkwin, 1);
	tkPriv->popup = menu;
	tkPriv->focus = rivet_get_focus(menu);
	rivet_set_focus(menu);
}
 
 
static int
rivet_mb_post1(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
  ...bind Menubutton <1> {
 	if {$tkPriv(inMenubutton) != ""} {
 	    tkMbPost $tkPriv(inMenubutton) %X %Y
 	}
     }
#endif
	int rootx, rooty;

	if(tkPriv->inMenubutton != 0) {
		rivet_rootcoords(rivetobj, xevent, &rootx, &rooty);
		rivet_mb_post(tkPriv->inMenubutton, rootx, rooty, 0);
	}
	return TCL_CONTINUE;
}

static int
rivet_mb_post2(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0
  ...bind Menubutton <space> {
 	tkMbPost %W
 	tkMenuFirstEntry [%W cget -menu]
     }
#endif
	rivet_mb_post(rivetobj, 0, 0, 1);
	rivet_menu_first_entry(
		rivet_path_to_rivetobj(
			rivet_get(rivetobj, "-menu")));
	return TCL_CONTINUE;
}

static int
rivet_menu_enter(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
#if 0

     /* Must set focus when mouse enters a menu, in order to allow
      * mixed-mode processing using both the mouse and the keyboard.
      */
     bind Menu <Enter> {
 	set tkPriv(window) %W
 	focus %W
     }
     if {($event == "Enter") && ([winfo class $w] == "Menu")} {
 	set tkPriv(window) $w
 	focus $w
 	%W activate @%y
     }
#endif
	static int initialized;

	tkPriv->window = rivetobj;
	rivet_set_focus(rivetobj);
	if(!initialized) {
		/* why this is only done on the first time it not completely
		 * explained 
		 */
		char buf[30];
		sprintf(buf, "@%d", ((XMotionEvent*)xevent)->y);
		rivet_va_cmd(rivetobj, "activate", buf, 0);
		initialized = 1;
	}
	return TCL_CONTINUE;
}


/* 
 * tkMenuBind --
 * This procedure is invoked the first time the mouse enters a menubutton
 * widget or a menubutton widget receives the input focus.  It creates
 * all of the class bindings for both menubuttons and menus.
 *
 * Arguments:
 * w -		The widget that was just entered  or  just received
 *		the input focus.
 * event -	Indicates which event caused the procedure to be invoked
 *		(Enter or FocusIn).  It is used so that we can carry out
 *		the functions of that event in addition to setting up
 *		bindings.
 */ 
void
rivet_menubutton_bind(widget)
	Rivetobj widget;
{
	if(rivet_is_class_initialized(widget->rivet_class))
		return;
	rivet_class_init_done(widget->rivet_class);

	if(
	(rivet_create_binding(0, widget->rivet_class->name, "<Enter>",
		rivet_mb_enter, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Leave>",
		rivet_mb_leave, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<1>",
		rivet_mb_post1, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Motion>",
		rivet_mb_motion, (ClientData)M_UP, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<B1-Motion>",
		rivet_mb_motion, (ClientData)M_DOWN, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<ButtonRelease-1>",
		rivet_mb_button_up, (ClientData)M_DOWN, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<space>",
		rivet_mb_post2, (ClientData)M_DOWN, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Return>",
		rivet_mb_post2, (ClientData)M_DOWN, 0, 0) == TCL_ERROR))
			;
}

void
rivet_menu_bind(widget)
	Rivetobj widget;
{
	if(rivet_is_class_initialized(widget->rivet_class))
		return;
	rivet_class_init_done(widget->rivet_class);

	if(
	(rivet_create_binding(0, widget->rivet_class->name, "<Enter>",
		rivet_menu_enter, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Leave>",
		rivet_menu_leave, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Motion>",
		rivet_menu_motion, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<ButtonPress>",
		rivet_menu_button_down, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<ButtonRelease>",
		rivet_menu_invoke, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<space>",
		rivet_menu_invoke, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Return>",
		rivet_menu_invoke, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Escape>",
		rivet_menu_escape, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Left>",
		rivet_menu_left_right, (ClientData)M_LEFT, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Right>",
		rivet_menu_left_right, (ClientData)M_RIGHT, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Up>",
		rivet_menu_next_entry, (ClientData)-1, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<Down>",
		rivet_menu_next_entry, (ClientData)1, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, widget->rivet_class->name, "<KeyPress>",
		rivet_menu_traverse_within_menu, 0, 0, 0) == TCL_ERROR) ||

	(rivet_create_binding(0, "all", "<Alt-KeyPress>",
		rivet_menu_traverse_to_menu, 0, 0, 0) == TCL_ERROR) ||
	(rivet_create_binding(0, "all", "<F10>",
		rivet_menu_first_menu, 0, 0, 0) == TCL_ERROR))
			;
}

