
#include "rivet.h"
/*
 *--------------------------------------------------------------
 * Following code from tk.tcl.
 *--------------------------------------------------------------
 */
int tk_strictMotif;
tkPrivType *tkPriv;

void
rivet_screen_changed(interp, displayname, index)
	Tcl_Interp *interp;
	char *displayname;
	int index;
{
	char dispandscr[200];
	static int initialized = 0;
        Tcl_HashEntry *hPtr;
	static Tcl_HashTable tbl;
	int unused;

	if(!initialized) {
		/* build hash table */
		initialized = 1;
		Tcl_InitHashTable(&tbl, TCL_STRING_KEYS);
	}

	/* search */
	sprintf(dispandscr, "%s.%d", displayname, index);
	hPtr = Tcl_FindHashEntry(&tbl, dispandscr);

	if(hPtr) {
		/* search found it */
		tkPriv = (tkPrivType*)Tcl_GetHashValue(hPtr);
	} else {
		/* search did not find it */
		tkPriv = (tkPrivType*) malloc(sizeof(tkPrivType));
		memset((void*)tkPriv, 0, sizeof(tkPrivType));

		tkPriv->buttons = "0";
		tkPriv->focusContinue = "0";
		tkPriv->focusDir = "next";
		tkPriv->focusOrigin = "";
		tkPriv->grab = "";
		tkPriv->selectMode = "char";
		strcpy(tkPriv->relief, "raised");

		hPtr = Tcl_CreateHashEntry(&tbl, dispandscr, &unused);
		Tcl_SetHashValue(hPtr, tkPriv);
	}
}

void rivet_cancel_repeat()
{
	Tk_DeleteTimerHandler(tkPriv->afterId);
	tkPriv->afterId = 0;
}

static int
focus_next_prev(rivetobj, xevent, assoc)
	Rivetobj rivetobj;
	XEvent *xevent;
	ClientData assoc;
{
	Rivetobj nextorprev;

	if(assoc)
		nextorprev = rivet_focus_prev(rivetobj);
	else
		nextorprev = rivet_focus_next(rivetobj);

	rivet_va_func(rivetobj, Tk_FocusCmd, rivet_path(nextorprev), 0);
	return TCL_CONTINUE;
}

/*
 *--------------------------------------------------------------
 *
 * rivet_init_tk --
 *
 *	Initialize.  Essentially has the same effect as Tk_Init.
 * 
 *--------------------------------------------------------------
 */
int
rivet_init_lib()
{
	tk_strictMotif = 0;
	rivet_screen_changed(rivet_main_window->interp,
		Tk_DisplayName((Tk_Window)rivet_main_window->tkwin),
                Tk_ScreenNumber(rivet_main_window->tkwin));

	/*
	 * bind all <Tab> {focus [tk_focusNext %W]}
	 * bind all <Shift-Tab> {focus [tk_focusPrev %W]}
	 */
	rivet_create_binding(0, "all", "<Tab>",
		focus_next_prev, 0, 0, 0);
	rivet_create_binding(0, "all", "<Shift-Tab>",
		focus_next_prev, (ClientData)1, 0, 0);
}

